<%@ LANGUAGE="JavaScript" %>
<!--#INCLUDE FILE="i18n.asp" -->
<%
/***********************************************************
                      Operator Wiki

               JavaScript based WIKI System

                     Created by WISH

    Email:    W i s h s t u d i o @ g m a i l . c o m
***********************************************************/
var WIKI_Name='Operator Wiki';

var WIKI_Database_File_Name='wiki.mdb';
var WIKI_Database_Conn=Server.CreateObject('ADODB.Connection');
var WIKI_Database_Conn_Command='DRIVER={Microsoft Access Driver (*.mdb)}; DBQ='+Server.MapPath('wiki.mdb')+';';

var WIKI_Article_Name=(Request.QueryString('article')+'').toLowerCase();
var WIKI_Activity=Request.QueryString('activity')+'';

var Today=new Date();
var WIKI_Date=GetText('dateformat');
var WIKI_Time=GetText('timeformat');

WIKI_Date=WIKI_Date.replace(/%year/g,Today.getYear());
WIKI_Date=WIKI_Date.replace(/%month/g,Today.getMonth());
WIKI_Date=WIKI_Date.replace(/%date/g,Today.getDate());

WIKI_Time=WIKI_Time.replace(/%hour/g,(Today.getHours()<10?'0':'')+Today.getHours());
WIKI_Time=WIKI_Time.replace(/%minute/g,(Today.getMinutes()<10?'0':'')+Today.getMinutes());
WIKI_Time=WIKI_Time.replace(/%second/g,(Today.getSeconds()<10?'0':'')+Today.getSeconds());

if(WIKI_Article_Name=='undefined'||WIKI_Article_Name=='') Response.Redirect('?activity=show&article='+GetText('homepage'));
//Arg error
%>
<!--#INCLUDE FILE="macros.asp" -->
<%
WIKI_Database_Conn.Open(WIKI_Database_Conn_Command);

switch(WIKI_Activity){
  case 'show':
    show();
    break;
  case 'edit':
    edit();
    break;
  case 'editok':
    editok();
    break;
  case 'create':
    create();
    break;
  default:
    WIKI_Database_Conn.Close();
    Response.Redirect('?activity=show&article='+GetText('homepage'));
}

WIKI_Database_Conn.Close();
Response.End();

function debug(text){Response.Write(text);}

function html_head(HTML_Title) {
//Display html head
%><html>
<head>
<meta http-equiv="Content-Type" content="text/html; charset=<%=GetText('meta_charset')%>">
<title><%=HTML_Title%> - <%=WIKI_Name%></title>
<style type="text/css">
BODY {margin-left: 2em; margin-right: 2em;font-size: 10.5pt; font-family: helvetica;}
P.title {font-family: Georgia; color: #FF6600; font-size: 14pt; font-weight: bold; text-decoration: none;}
P.diff {font-family: courier; font-size: 10.5pt;}
P.diff A.add{color: #003399; background: #cceeff;}
P.diff A.minus{color: #AA0066; background: #ffccee;}
P.content {font-size: 10.5pt; font-family: helvetica;}
A.offsite {color: #6699cc; }
A {color: #993333; }
PRE{background: #f6f6f6; border: 1px dashed #333333; padding: 5px;}
TABLE{border: 1px solid #999999; padding: 5px; border-collapse: collapse;}
TABLE TR TD{border: 1px solid #999999; padding: 5px; font-size: 10.5pt;}
P.wikitool {margin-left: -.5em; }
P.wikitool A{padding-left: .5em; padding-right: .5em; text-decoration: none; font-size: 14px; font-weight: bold; color: #660000; font-family: sans-serif}
P.wikitool A:hover {background: #660000; color:#FFFFFF;}
P.pageinfo {font-size: 9pt; font-style: italic; color: #999999;}
TABLE.history, TABLE.rc {border: 0px; width:90%; text-align: center; border-collapse: collapse;}
TABLE.history TR TH {font-size: 14px; font-weight: bold; font-family: serif; background: #44aa33; color: white; }
TABLE.history TR TD { border: 0px; font-size: 14px; font-family: sans; padding: 5px;}
A.wanted {vertical-align:super; background: #ececec; text-decoration: none; color: #009999;}
TD,INPUT {font-size: 10pt;}
TD {border: 1px solid dim gray;}
H1 {margin: 0; padding: 0; color: black; font-size: 2em; font-weight: bold;  line-height: 1.2em;}
H2 {text-decoration: none; color: black;}
H2, H3, H4, H5, H6 {margin: 1.5em 0 0 0; padding: 0; color: black; line-height: 1.2em;}	
H2 {font-size: 1.6em;}
H3 {font-size: 1.3em;}
H4 {font-size: 1.1em;}
H5, H6 {font-size: 1em;}
HR {height: 1pt; background-color: #9C9C9C; border: 0;}
.HR1 {height: 2pt;}
.HR2 {height: 3pt;}
.HR3 {height: 4pt;}
.HR4 {height: 5pt;}
.HR5 {height: 6pt;}
.HR6 {height: 7pt;}
</style>

<body>
<h3 align=center style="color:#804080"><%=WIKI_Name%></h3>
<!--#INCLUDE FILE="head.asp" -->
<%
}

function html_end(){
//Display html end
%>
</body>
</html><%
}

function Wiki2HTML(ToConvert){
//Convert WIKI Code to HTML

  var result=ToConvert+'';
  var swapTexts=new Array();

  function SwapOutText(str){
    swapTexts.push(str);
    return swapTexts.length-1;
  }

  function SwapInText(idx){
    return swapTexts[idx--];
  }

  function ConvertComplex(ToConvert){
//Convert complex components like table, list, etc

    var lines=ToConvert.split('\n');
    var i,j,linestart,lineend=0;

//The programs below is table translator
    for(i=0;i<=lines.length;i++){
      if(/^(&nbsp;)*?\|\|.*\|\|$/g.test(lines[i])){
//Is it a table?

        if(linestart)
          lineend=i
        else{
          linestart=i;
          lineend=i;
        }
//Save line start and line end for the program below to create table

      }
      else if(linestart){
        for(j=linestart;j<=lineend;j++){
          lines[j]=lines[j].replace(/^/g,'');
          lines[j]=lines[j].replace(/^(&nbsp;)*?\|\|/g,'<tr><td>');
          lines[j]=lines[j].replace(/\|\|$/g,'</td></tr>');
          lines[j]=lines[j].replace(/\|\|/g,'</td><td>');
        }

        lines[linestart]='<table>'+lines[linestart];
        lines[lineend]=lines[lineend]+'</table>';
        linestart=0;
        lineend=0;
      }
    }

//The programs below is list translator
    linestart=0;
    for(i=0;i<lines.length;i++){
      if(/^(&nbsp;)+/g.test(lines[i]))
         lines[i]=lines[i].replace(/^((?:&nbsp;)+)/g,function($0,$1){
                                              var itslength,theresult;

                                              itslength=$1.length/12;

                                              theresult='';
                                              if(itslength>linestart){
                                                for(j=1;j<=(itslength-linestart);j++)
                                                  theresult+='<ul>';
                                              }
                                              else if(itslength<linestart){
                                                for(j=itslength;j<linestart;j++)
                                                  theresult+='</ul>';
                                              }
                                              linestart=itslength;
                                              return(theresult);
                                            })
      else if(linestart){
        for(j=1;j<=linestart;j++)
          lines[i]='</ul>'+lines[i];
        linestart=0;
      }
      lines[i]=lines[i].replace(/^((?:<ul>)*|(?:<\/ul>)*)\*(.*)$/g,'$1<li>$2</li>');
    }
    if(linestart)
      for(j=1;j<=linestart;j++)
        lines[lines.length-1]+='</ul>';

    return(lines.join('\n').replace(/<\/tr>\n<tr>/g,'</tr><tr>'));
  }

  function ConvertEmoticon(ToConvert){
//Convert emoticons

    var result=ToConvert;
    var i;
    var Emoticons=[ [/(&nbsp;|\s)\(!\)(&nbsp;|\s)/g,'idea.png'],
                    [/(&nbsp;|\s)\(\.\/\)(&nbsp;|\s)/g,'checkmark.png'],
                    [/(&nbsp;|\s)\/!\\(&nbsp;|\s)/g,'alert.png'],
                    [/(&nbsp;|\s)&lt;\:\((&nbsp;|\s)/g,'frown.png'],
                    [/(&nbsp;|\s)\:\((&nbsp;|\s)/g,'sad.png'],
                    [/(&nbsp;|\s)\:\)\)(&nbsp;|\s)/g,'smile3.png'],
                    [/(&nbsp;|\s)\:\)(&nbsp;|\s)/g,'smile.png'],
                    [/(&nbsp;|\s)\:\-\((&nbsp;|\s)/g,'sad.png'],
                    [/(&nbsp;|\s)\:\-\)\)(&nbsp;|\s)/g,'smile3.png'],
                    [/(&nbsp;|\s)\:\-\)(&nbsp;|\s)/g,'smile.png'],
                    [/(&nbsp;|\s)\:\-\?(&nbsp;|\s)/g,'tongue.png'],
                    [/(&nbsp;|\s)\:D(&nbsp;|\s)/g,'biggrin.png'],
                    [/(&nbsp;|\s)\:\\(&nbsp;|\s)/g,'ohwell.png'],
                    [/(&nbsp;|\s)\:o(&nbsp;|\s)/g,'redface.png'],
                    [/(&nbsp;|\s);\)(&nbsp;|\s)/g,'smile4.png'],
                    [/(&nbsp;|\s);\-\)(&nbsp;|\s)/g,'smile4.png'],
                    [/(&nbsp;|\s)&lt;!&gt;(&nbsp;|\s)/g,'attention.png'],
                    [/(&nbsp;|\s)&gt;\:&gt;(&nbsp;|\s)/g,'devil.png'],
                    [/(&nbsp;|\s)B\)(&nbsp;|\s)/g,'smile2.png'],
                    [/(&nbsp;|\s)B\-\)(&nbsp;|\s)/g,'smile2.png'],
                    [/(&nbsp;|\s)X\-\((&nbsp;|\s)/g,'angry.png'],
                    [/(&nbsp;|\s)\{\*\}(&nbsp;|\s)/g,'star_on.png'],
                    [/(&nbsp;|\s)\{1\}(&nbsp;|\s)/g,'prio1.png'],
                    [/(&nbsp;|\s)\{2\}(&nbsp;|\s)/g,'prio2.png'],
                    [/(&nbsp;|\s)\{3\}(&nbsp;|\s)/g,'prio3.png'],
                    [/(&nbsp;|\s)\{OK\}(&nbsp;|\s)/g,'thumbs-up.png'],
                    [/(&nbsp;|\s)\{X\}(&nbsp;|\s)/g,'icon-error.png'],
                    [/(&nbsp;|\s)\{da\}(&nbsp;|\s)/g,'flag-da.png'],
                    [/(&nbsp;|\s)\{de\}(&nbsp;|\s)/g,'flag-de.png'],
                    [/(&nbsp;|\s)\{en\}(&nbsp;|\s)/g,'flag-en.png'],
                    [/(&nbsp;|\s)\{es\}(&nbsp;|\s)/g,'flag-es.png'],
                    [/(&nbsp;|\s)\{fi\}(&nbsp;|\s)/g,'flag-fi.png'],
                    [/(&nbsp;|\s)\{fr\}(&nbsp;|\s)/g,'flag-fr.png'],
                    [/(&nbsp;|\s)\{it\}(&nbsp;|\s)/g,'flag-it.png'],
                    [/(&nbsp;|\s)\{i\}(&nbsp;|\s)/g,'icon-info.png'],
                    [/(&nbsp;|\s)\{ja\}(&nbsp;|\s)/g,'flag-ja.png'],
                    [/(&nbsp;|\s)\{ko\}(&nbsp;|\s)/g,'flag-ko.png'],
                    [/(&nbsp;|\s)\{nl\}(&nbsp;|\s)/g,'flag-nl.png'],
                    [/(&nbsp;|\s)\{o\}(&nbsp;|\s)/g,'star_off.png'],
                    [/(&nbsp;|\s)\{pt\}(&nbsp;|\s)/g,'flag-pt.png'],
                    [/(&nbsp;|\s)\{sv\}(&nbsp;|\s)/g,'flag-sv.png'],
                    [/(&nbsp;|\s)\{us\}(&nbsp;|\s)/g,'flag-us.png'],
                    [/(&nbsp;|\s)\{zh\}(&nbsp;|\s)/g,'flag-zh.png'],
                    [/(&nbsp;|\s)\|\)(&nbsp;|\s)/g,'tired.png'],
                    [/(&nbsp;|\s)\|\-\)(&nbsp;|\s)/g,'tired.png']
                  ];

    for(i=0;i<Emoticons.length;i++)
      result=result.replace(Emoticons[i][0],'$1<img src="emoticon/'+Emoticons[i][1]+'">$2');
    return(result);
  }

//Improve content
  result=result.replace(/\r\n?/mg, "\n");

//HTML codes
  result=result.replace(/&/g,'&amp;');
  result=result.replace(/</g,'&lt;');
  result=result.replace(/>/g,'&gt;');
  result=result.replace(/"/g,'&quot;');
  result=result.replace(/ /g,'&nbsp;');

//Code spans
  result=result.replace(/{{{\n*((.|\n)+?)}}}/mg, function($0,$1){return('@'+SwapOutText('<pre>'+$1+'</pre>')+'@');});
  result=result.replace(/\`\`(.+?)\`\`/mg,function($0,$1){return('@'+SwapOutText('<tt>'+$1+'</tt>')+'@');});

//Macros
  result=result.replace(/\[[Mm][Aa][Cc][Rr][Oo]\:(.+?\(.*?\))\]/g,function($0,$1){
                                                                             try{
                                                                               var theresult;
                                                                                 eval('theresult=("@"+SwapOutText(macro_'+$1.toLowerCase()+')+"@");');
                                                                               return(theresult);
                                                                             }
                                                                             catch(e){
                                                                               return('');
                                                                             }
                                                                           });

//Headers
  result=result.replace(/={6}\s*(.+?)\s*=+/mg,'<h6>$1</h6>');
  result=result.replace(/={5}\s*(.+?)\s*=+/mg,'<h5>$1</h5>');
  result=result.replace(/={4}\s*(.+?)\s*=+/mg,'<h4>$1</h4>');
  result=result.replace(/={3}\s*(.+?)\s*=+/mg,'<h3>$1</h3>');
  result=result.replace(/={2}\s*(.+?)\s*=+/mg,'<h2>$1</h2>');
  result=result.replace(/={1}\s*(.+?)\s*=+/mg,'<h1>$1</h1>');

//HR
  result=result.replace(/-{10}-*/g,'<hr class="hr6">');
  result=result.replace(/-{9}/g,'<hr class="hr5">');
  result=result.replace(/-{8}/g,'<hr class="hr4">');
  result=result.replace(/-{7}/g,'<hr class="hr3">');
  result=result.replace(/-{6}/g,'<hr class="hr2">');
  result=result.replace(/-{5}/g,'<hr class="hr1">');
  result=result.replace(/-{4}/g,'<hr>');

//Text styles
  result=result.replace(/__(.+?)__/g,'<u>$1</u>');
  result=result.replace(/'''(.+?)'''/g,'<b>$1</b>');
  result=result.replace(/''(.+?)''/g,'<i>$1</i>');
  result=result.replace(/\^(.+?)\^/g,'<sup>$1</sup>');
  result=result.replace(/,,(.+?),,/g,'<sub>$1</sub>');

//Emoticons
  result=ConvertEmoticon(result);

//In-article link
  result=result.replace(/\[(\d+)\]/g,'<a href="#$1"><sup>$1</sup></a>');
  result=result.replace(/\[(\d+)\-&gt;\]((?:.|\n)+?)\[&lt;\-]/g,'<span id="$1">($1)&nbsp;&nbsp;$2</span>');

//Inter wiki map
  result=result.replace(/\[&quot;(.+?)&quot;\]/g,function($0,$1){return('@'+SwapOutText('<a href="?activity=show&article='+$1+'">'+$1+'</a>')+'@');});

//Inside image
  result=result.replace(/\[[Ii][Mm][Gg]\](.+?)\[\/[Ii][Mm][Gg]\]/g,function($0,$1){return('@'+SwapOutText('<img src="'+$1+'">')+'@');});

//Url link
  result=result.replace(/\[[Uu][Rr][Ll]=(.+?)\](.+?)\[\/[Uu][Rr][Ll]\]/g,function($0,$1,$2){return('@'+SwapOutText('<a href="'+$1+'">'+$2+'</a>')+'@');});
  result=result.replace(/\[(.+?)\]/g,function($0,$1){return('@'+SwapOutText('<a href="'+$1+'">'+$1+'</a>')+'@');});

//Inter wiki map
  result=result.replace(/\b([A-Z](?:[A-Z]|[a-z])+?)\b/g,function($0,$1){return('@'+SwapOutText('<a href="?activity=show&article='+$1+'">'+$1+'</a>')+'@');});
  result=result.replace(/\b((?:[A-Z]|[a-z]|[0-9])+?@(?:[\w0-9])+?\.(?:[A-Z]|[a-z]|[0-9])+?)\b/g,function($0,$1){return('@'+SwapOutText('<a href="mailto:'+$1+'">'+$1+'</a>')+'@');});

//Complex component
  result=ConvertComplex(result);
  result=result.replace(/(<td)>\((.+?)\)/g,function($0,$1,$2){
                                             var resulttext=$1+' ';
                                             if($2.match(/(.*?)([\|\-])(\d)(.*)/g))
                                               resulttext+=$2.replace(/(.*?)([\|\-])(\d)(.*)/g,function($0,$1,$2,$3,$4){return((($2=='-')?'col':'row')+'span="'+$3+'" ');});
                                             resulttext+='style="'+$2.replace(/(.*?)([\|\-])(\d)(?:&nbsp;)?(.*)/g,'$1$4')+'">';
                                             resulttext=resulttext.replace(/(&lt;|&gt;|\:)/g,function($0,$1){return('text-align:'+($1=='&lt;'?'left':($1=='&gt;'?'right':'center'))+'; ');});
                                             resulttext=resulttext.replace(/([\^Vv])/g,function($0,$1){return('vertical-align:'+($1=='^'?'top':'bottom')+'; ');});
                                             resulttext=resulttext.replace(/(\d+%)/g,'width:$1; ');
                                             resulttext=resulttext.replace(/(#[0-9A-Fa-f]{6})/g,'background-color:$1');
                                             return(resulttext);
                                           });

//Paragraph
  result=result.replace(/\n\n/g,'<p>');
  result=result.replace(/\n/g,'<br>');

//Swap In all the pending text
  while(result.match(/(?:@(\d+)@)/))
    result=result.replace(/(?:@(\d+)@)/g, function($0, $1){return(SwapInText($1)); });

  return(result);
}

function articlenotfound(){
//When article not found, the process will call this procedure
%><p>&nbsp;&nbsp;&nbsp;&nbsp;<%=GetText('noarticle').replace(/%s/g,WIKI_Article_Name)%></p>
<p>&nbsp;&nbsp;&nbsp;&nbsp;<a href="?activity=create&article=<%=WIKI_Article_Name%>"><%=GetText('ok')%></a></p><%
}

function articlefound(){
//When create a article, if the article is found, the procedure 'create' will call this procedure
  WIKI_Database_Conn.Close();
  Response.Redirect('?activity=show&article='+WIKI_Article_Name);
}

function show(){
//Show the article
  html_head(WIKI_Article_Name);

%><p class="title"><%=WIKI_Article_Name%></p>
<%

  var ArticleAuthor,ArticleDate;
  var WIKI_Database_Rs=Server.CreateObject("ADODB.Recordset");
  var WIKI_Database_Rs_Command="SELECT * FROM [wiki] WHERE title='"+WIKI_Article_Name+"'";
  WIKI_Database_Rs.Open(WIKI_Database_Rs_Command,WIKI_Database_Conn,1,3);
  if(WIKI_Database_Rs.Eof || WIKI_Database_Rs.Bof)
    articlenotfound()
  else {
    ArticleAuthor=WIKI_Database_Rs('author');
    ArticleDate=WIKI_Database_Rs('date');
    Response.Write(Wiki2HTML(WIKI_Database_Rs('content')));
%><br>
<p class="wikitool"><a href="?activity=edit&article=<%=WIKI_Article_Name%>"><%=GetText('editthispage')%></a></p><%
  }
  WIKI_Database_Rs.Close();

  html_end();
}

function editok(){
//Save edited page
  var ArticleAuthor,ArticleDate;
  var WIKI_Database_Rs=Server.CreateObject("ADODB.Recordset");
  var WIKI_Database_Rs_Command="SELECT * FROM [wiki] WHERE title='"+WIKI_Article_Name+"'";
  WIKI_Database_Rs.Open(WIKI_Database_Rs_Command,WIKI_Database_Conn,1,3);
  if(WIKI_Database_Rs.Eof || WIKI_Database_Rs.Bof){
    WIKI_Database_Rs.Close();
    WIKI_Database_Conn.Close();
    Response.Redirect('?activity=edit&article='+WIKI_Article_Name);
  }
  else {
    if(Request.Form('content')+''=='undefined')
      Response.Write(GetText('formerror'))
    else {
      WIKI_Database_Rs('content')=Request.Form('content');
      WIKI_Database_Rs('date')=WIKI_Date;
      WIKI_Database_Rs('time')=WIKI_Time;
      WIKI_Database_Rs.Update();
      WIKI_Database_Rs.Close();
      WIKI_Database_Conn.Close();
      Response.Redirect('?activity=show&article='+WIKI_Article_Name);
    }
    WIKI_Database_Rs.Close();
  }
}

function edit(){
//Show edit page

  html_head(GetText('edit')+WIKI_Article_Name);

  var ArticleAuthor,ArticleDate;
  var WIKI_Database_Rs=Server.CreateObject("ADODB.Recordset");
  var WIKI_Database_Rs_Command="SELECT * FROM [wiki] WHERE title='"+WIKI_Article_Name+"'";
  WIKI_Database_Rs.Open(WIKI_Database_Rs_Command,WIKI_Database_Conn,1,3);
  if(WIKI_Database_Rs.Eof || WIKI_Database_Rs.Bof)
    articlenotfound();

%><h4 align=center><%=GetText('isediting').replace(/%s/g,WIKI_Article_Name)%></h4>
<br>
<form action="?activity=editok&article=<%=WIKI_Article_Name%>" method="post">
<textarea rows=20 cols=99 name="content">
<%=WIKI_Database_Rs('content')%></textarea>
<br>
<input type=submit value="<%=GetText('save')%>">&nbsp;&nbsp;<input type=button value="<%=GetText('cancel')%>" onclick="javascript:document.location.href='?activity=show&article=<%=WIKI_Article_Name%>';">
</form><%

  WIKI_Database_Rs.Close();
  html_end();
}

function create(){
//Create a page
  var WIKI_Database_Rs=Server.CreateObject("ADODB.Recordset");
  var WIKI_Database_Rs_Command="SELECT * FROM [wiki] WHERE title='"+WIKI_Article_Name+"'";
  WIKI_Database_Rs.Open(WIKI_Database_Rs_Command,WIKI_Database_Conn,1,3);
  if(!(WIKI_Database_Rs.Eof || WIKI_Database_Rs.Bof)) {
    WIKI_Database_Rs.Close();
    articlefound();
  }
  else {
    WIKI_Database_Rs.AddNew();
    WIKI_Database_Rs('title')=WIKI_Article_Name;
    WIKI_Database_Rs('author')='anonymous';
    WIKI_Database_Rs('date')=WIKI_Date;
    WIKI_Database_Rs('time')=WIKI_Time;
    WIKI_Database_Rs('content')=GetText('putsentencehere').replace(/%s/g,WIKI_Article_Name);
    WIKI_Database_Rs.Update();
    WIKI_Database_Rs.Close();
    WIKI_Database_Conn.Close();
    Response.Redirect('?activity=edit&article='+WIKI_Article_Name);
  }
}
%>